diff --git a/sysdeps/riscv/rv32/rvd/Implies b/sysdeps/riscv/rv32/rvd/Implies
index 1151214e8f..9438838e98 100644
--- a/sysdeps/riscv/rv32/rvd/Implies
+++ b/sysdeps/riscv/rv32/rvd/Implies
@@ -1,3 +1,2 @@
-riscv/rv32/rvf
 riscv/rvd
 riscv/rvf
diff --git a/sysdeps/riscv/rv64/rvd/s_lrint.c b/sysdeps/riscv/rv64/rvd/s_lrint.c
deleted file mode 100644
index d9f65a27c5..0000000000
--- a/sysdeps/riscv/rv64/rvd/s_lrint.c
+++ /dev/null
@@ -1,30 +0,0 @@
-/* lrint().  RISC-V version.
-   Copyright (C) 2017-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <libm-alias-double.h>
-#include <stdint.h>
-
-long int
-__lrint (double x)
-{
-  int64_t res;
-  asm ("fcvt.l.d %0, %1" : "=r" (res) : "f" (x));
-  return res;
-}
-
-libm_alias_double (__lrint, lrint)
diff --git a/sysdeps/riscv/rv64/rvd/s_lround.c b/sysdeps/riscv/rv64/rvd/s_lround.c
deleted file mode 100644
index 73e513c783..0000000000
--- a/sysdeps/riscv/rv64/rvd/s_lround.c
+++ /dev/null
@@ -1,30 +0,0 @@
-/* llround().  RISC-V version.
-   Copyright (C) 2017-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <libm-alias-double.h>
-#include <stdint.h>
-
-long int
-__lround (double x)
-{
-  int64_t res;
-  asm ("fcvt.l.d %0, %1, rmm" : "=r" (res) : "f" (x));
-  return res;
-}
-
-libm_alias_double (__lround, lround)
diff --git a/sysdeps/riscv/rv64/rvf/s_lrintf.c b/sysdeps/riscv/rv64/rvf/s_lrintf.c
deleted file mode 100644
index c7c033c3be..0000000000
--- a/sysdeps/riscv/rv64/rvf/s_lrintf.c
+++ /dev/null
@@ -1,31 +0,0 @@
-/* lrintf().  RISC-V version.
-   Copyright (C) 2017-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <math.h>
-#include <libm-alias-float.h>
-#include <stdint.h>
-
-long int
-__lrintf (float x)
-{
-  int64_t res;
-  asm ("fcvt.l.s %0, %1" : "=r" (res) : "f" (x));
-  return res;
-}
-
-libm_alias_float (__lrint, lrint)
diff --git a/sysdeps/riscv/rv64/rvf/s_lroundf.c b/sysdeps/riscv/rv64/rvf/s_lroundf.c
deleted file mode 100644
index 76817cadad..0000000000
--- a/sysdeps/riscv/rv64/rvf/s_lroundf.c
+++ /dev/null
@@ -1,31 +0,0 @@
-/* lroundf().  RISC-V version.
-   Copyright (C) 2017-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <math.h>
-#include <libm-alias-float.h>
-#include <stdint.h>
-
-long int
-__lroundf (float x)
-{
-  int64_t res;
-  asm ("fcvt.l.s %0, %1, rmm" : "=r" (res) : "f" (x));
-  return res;
-}
-
-libm_alias_float (__lround, lround)
diff --git a/sysdeps/riscv/rv32/rvd/s_lrint.c b/sysdeps/riscv/rvd/s_lrint.c
similarity index 81%
rename from sysdeps/riscv/rv32/rvd/s_lrint.c
rename to sysdeps/riscv/rvd/s_lrint.c
index bdec792f18..46a7fb3da4 100644
--- a/sysdeps/riscv/rv32/rvd/s_lrint.c
+++ b/sysdeps/riscv/rvd/s_lrint.c
@@ -1,4 +1,4 @@
-/* lrint().  The 32-bit RISC-V (RV32) version.
+/* lrint().  RISC-V version.
    Copyright (C) 2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
@@ -16,15 +16,22 @@
    License along with the GNU C Library.  If not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <math.h>
 #include <libm-alias-double.h>
 #include <stdint.h>
 
+#if __WORDSIZE == 64
+# define OP "fcvt.l.d"
+#elif __WORDSIZE == 32
+# define OP "fcvt.w.d"
+#else
+# error Unsupported
+#endif
+
 long int
 __lrint (double x)
 {
-  int32_t res;
-  asm ("fcvt.w.d %0, %1" : "=r" (res) : "f" (x));
+  long int res;
+  asm (OP "\t%0, %1" : "=r" (res) : "f" (x));
   return res;
 }
 
diff --git a/sysdeps/riscv/rv32/rvd/s_lround.c b/sysdeps/riscv/rvd/s_lround.c
similarity index 80%
rename from sysdeps/riscv/rv32/rvd/s_lround.c
rename to sysdeps/riscv/rvd/s_lround.c
index 78bccd47ae..95753dcb39 100644
--- a/sysdeps/riscv/rv32/rvd/s_lround.c
+++ b/sysdeps/riscv/rvd/s_lround.c
@@ -1,4 +1,4 @@
-/* lround().  32-bit RISC-V (RV32) version.
+/* llround().  RISC-V version.
    Copyright (C) 2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
@@ -16,15 +16,22 @@
    License along with the GNU C Library.  If not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <math.h>
 #include <libm-alias-double.h>
 #include <stdint.h>
 
+#if __WORDSIZE == 64
+# define OP "fcvt.l.d"
+#elif __WORDSIZE == 32
+# define OP "fcvt.w.d"
+#else
+# error Unsupported
+#endif
+
 long int
 __lround (double x)
 {
-  int32_t res;
-  asm ("fcvt.w.d %0, %1, rmm" : "=r" (res) : "f" (x));
+  long int res;
+  asm (OP "\t%0, %1, rmm" : "=r" (res) : "f" (x));
   return res;
 }
 
diff --git a/sysdeps/riscv/rv32/rvf/s_lrintf.c b/sysdeps/riscv/rvf/s_lrintf.c
similarity index 81%
rename from sysdeps/riscv/rv32/rvf/s_lrintf.c
rename to sysdeps/riscv/rvf/s_lrintf.c
index b8e1df439e..84fca99526 100644
--- a/sysdeps/riscv/rv32/rvf/s_lrintf.c
+++ b/sysdeps/riscv/rvf/s_lrintf.c
@@ -1,4 +1,4 @@
-/* lrintf().  32-bit RISC-V (RV32) version.
+/* lrintf().  RISC-V version.
    Copyright (C) 2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
@@ -20,11 +20,19 @@
 #include <libm-alias-float.h>
 #include <stdint.h>
 
+#if __WORDSIZE == 64
+# define OP "fcvt.l.s"
+#elif __WORDSIZE == 32
+# define OP "fcvt.w.s"
+#else
+# error Unsupported
+#endif
+
 long int
 __lrintf (float x)
 {
-  int32_t res;
-  asm ("fcvt.w.s %0, %1" : "=r" (res) : "f" (x));
+  long res;
+  asm (OP "\t%0, %1" : "=r" (res) : "f" (x));
   return res;
 }
 
diff --git a/sysdeps/riscv/rv32/rvf/s_lroundf.c b/sysdeps/riscv/rvf/s_lroundf.c
similarity index 81%
rename from sysdeps/riscv/rv32/rvf/s_lroundf.c
rename to sysdeps/riscv/rvf/s_lroundf.c
index 32f9925084..eba9b7adce 100644
--- a/sysdeps/riscv/rv32/rvf/s_lroundf.c
+++ b/sysdeps/riscv/rvf/s_lroundf.c
@@ -1,4 +1,4 @@
-/* lroundf().  32-bit RISC-V (RV32) version.
+/* lroundf().  RISC-V version.
    Copyright (C) 2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
@@ -20,11 +20,19 @@
 #include <libm-alias-float.h>
 #include <stdint.h>
 
+#if __WORDSIZE == 64
+# define OP "fcvt.l.s"
+#elif __WORDSIZE == 32
+# define OP "fcvt.w.s"
+#else
+# error Unsupported
+#endif
+
 long int
 __lroundf (float x)
 {
-  int32_t res;
-  asm ("fcvt.w.s %0, %1, rmm" : "=r" (res) : "f" (x));
+  long res;
+  asm (OP "\t%0, %1, rmm" : "=r" (res) : "f" (x));
   return res;
 }
 