diff --git a/sysdeps/csky/fpu/libm-test-ulps b/sysdeps/csky/fpu/libm-test-ulps
index 480432a..6e1356e 100644
--- a/sysdeps/csky/fpu/libm-test-ulps
+++ b/sysdeps/csky/fpu/libm-test-ulps
@@ -48,8 +48,8 @@ double: 1
 float: 1
 
 Function: "asinh":
-double: 1
-float: 1
+double: 2
+float: 2
 
 Function: "asinh_downward":
 double: 3
@@ -329,7 +329,7 @@ double: 1
 float: 1
 
 Function: "cbrt":
-double: 3
+double: 4
 float: 1
 
 Function: "cbrt_downward":
@@ -505,6 +505,7 @@ float: 2
 
 Function: "cos":
 double: 1
+float: 1
 
 Function: "cos_downward":
 double: 1
@@ -519,15 +520,15 @@ double: 1
 float: 1
 
 Function: "cosh":
-double: 1
-float: 1
+double: 2
+float: 2
 
 Function: "cosh_downward":
-double: 2
+double: 3
 float: 1
 
 Function: "cosh_towardzero":
-double: 2
+double: 3
 float: 1
 
 Function: "cosh_upward":
@@ -737,8 +738,8 @@ double: 1
 float: 1
 
 Function: "erfc":
-double: 3
-float: 2
+double: 5
+float: 3
 
 Function: "erfc_downward":
 double: 5
@@ -752,6 +753,10 @@ Function: "erfc_upward":
 double: 5
 float: 6
 
+Function: "exp":
+double: 1
+float: 1
+
 Function: "exp10":
 double: 2
 
@@ -810,19 +815,19 @@ float: 1
 
 Function: "gamma":
 double: 4
-float: 3
+float: 7
 
 Function: "gamma_downward":
 double: 5
-float: 4
+float: 7
 
 Function: "gamma_towardzero":
 double: 5
-float: 4
+float: 6
 
 Function: "gamma_upward":
 double: 5
-float: 5
+float: 6
 
 Function: "hypot":
 double: 1
@@ -838,27 +843,27 @@ double: 1
 
 Function: "j0":
 double: 2
-float: 2
+float: 8
 
 Function: "j0_downward":
 double: 2
 float: 4
 
 Function: "j0_towardzero":
-double: 3
-float: 2
+double: 4
+float: 5
 
 Function: "j0_upward":
-double: 3
-float: 2
+double: 4
+float: 5
 
 Function: "j1":
-double: 1
-float: 2
+double: 2
+float: 9
 
 Function: "j1_downward":
 double: 3
-float: 3
+float: 5
 
 Function: "j1_towardzero":
 double: 3
@@ -886,19 +891,19 @@ float: 5
 
 Function: "lgamma":
 double: 4
-float: 3
+float: 7
 
 Function: "lgamma_downward":
 double: 5
-float: 4
+float: 7
 
 Function: "lgamma_towardzero":
 double: 5
-float: 4
+float: 6
 
 Function: "lgamma_upward":
 double: 5
-float: 5
+float: 6
 
 Function: "log10":
 double: 2
@@ -962,6 +967,7 @@ float: 1
 
 Function: "sin":
 double: 1
+float: 1
 
 Function: "sin_downward":
 double: 1
@@ -999,7 +1005,7 @@ double: 3
 float: 3
 
 Function: "sinh_towardzero":
-double: 2
+double: 3
 float: 2
 
 Function: "sinh_upward":
@@ -1038,28 +1044,28 @@ double: 3
 float: 3
 
 Function: "tgamma":
-double: 5
-float: 4
+double: 9
+float: 8
 
 Function: "tgamma_downward":
-double: 5
-float: 5
+double: 8
+float: 7
 
 Function: "tgamma_towardzero":
-double: 5
-float: 4
+double: 9
+float: 7
 
 Function: "tgamma_upward":
-double: 4
-float: 4
+double: 9
+float: 8
 
 Function: "y0":
-double: 2
-float: 1
+double: 3
+float: 8
 
 Function: "y0_downward":
 double: 3
-float: 4
+float: 6
 
 Function: "y0_towardzero":
 double: 3
@@ -1067,7 +1073,7 @@ float: 3
 
 Function: "y0_upward":
 double: 3
-float: 5
+float: 6
 
 Function: "y1":
 double: 3
diff --git a/sysdeps/csky/nofpu/libm-test-ulps b/sysdeps/csky/nofpu/libm-test-ulps
index 80bdea4..8a2de74 100644
--- a/sysdeps/csky/nofpu/libm-test-ulps
+++ b/sysdeps/csky/nofpu/libm-test-ulps
@@ -48,8 +48,8 @@ double: 1
 float: 1
 
 Function: "asinh":
-double: 1
-float: 1
+double: 2
+float: 2
 
 Function: "asinh_downward":
 double: 3
@@ -327,7 +327,7 @@ Function: Imaginary part of "catanh_upward":
 float: 1
 
 Function: "cbrt":
-double: 3
+double: 4
 float: 1
 
 Function: "cbrt_downward":
@@ -518,8 +518,8 @@ double: 1
 float: 2
 
 Function: "cosh":
-double: 1
-float: 1
+double: 2
+float: 2
 
 Function: "cosh_downward":
 double: 1
@@ -736,8 +736,8 @@ double: 1
 float: 1
 
 Function: "erfc":
-double: 3
-float: 2
+double: 5
+float: 3
 
 Function: "erfc_downward":
 double: 5
@@ -752,6 +752,7 @@ double: 5
 float: 6
 
 Function: "exp":
+double: 1
 float: 1
 
 Function: "exp10":
@@ -812,7 +813,7 @@ float: 1
 
 Function: "gamma":
 double: 4
-float: 4
+float: 7
 
 Function: "gamma_downward":
 double: 5
@@ -840,7 +841,7 @@ double: 1
 
 Function: "j0":
 double: 2
-float: 2
+float: 8
 
 Function: "j0_downward":
 double: 2
@@ -855,8 +856,8 @@ double: 3
 float: 2
 
 Function: "j1":
-double: 1
-float: 2
+double: 2
+float: 9
 
 Function: "j1_downward":
 double: 3
@@ -888,7 +889,7 @@ float: 5
 
 Function: "lgamma":
 double: 4
-float: 4
+float: 7
 
 Function: "lgamma_downward":
 double: 5
@@ -1074,8 +1075,8 @@ double: 3
 float: 3
 
 Function: "tgamma":
-double: 5
-float: 4
+double: 9
+float: 8
 
 Function: "tgamma_downward":
 double: 5
@@ -1090,8 +1091,8 @@ double: 4
 float: 4
 
 Function: "y0":
-double: 2
-float: 1
+double: 3
+float: 8
 
 Function: "y0_downward":
 double: 3