diff --git a/sysdeps/ieee754/float128/Versions b/sysdeps/ieee754/float128/Versions
index 2eebc6f1b0..8e644385f4 100644
--- a/sysdeps/ieee754/float128/Versions
+++ b/sysdeps/ieee754/float128/Versions
@@ -4,6 +4,7 @@
 %endif
 libc {
   FLOAT128_VERSION {
+    __isnanf128;
     __strtof128_internal;
     __wcstof128_internal;
   }
@@ -30,7 +31,6 @@ libm {
     __hypotf128_finite;
     __iseqsigf128;
     __isinff128;
-    __isnanf128;
     __issignalingf128;
     __j0f128_finite;
     __j1f128_finite;
diff --git a/sysdeps/mach/hurd/i386/libc.abilist b/sysdeps/mach/hurd/i386/libc.abilist
index 509e9b7cb0..58b0120d58 100644
--- a/sysdeps/mach/hurd/i386/libc.abilist
+++ b/sysdeps/mach/hurd/i386/libc.abilist
@@ -1995,6 +1995,7 @@ GLIBC_2.25 gnu_dev_minor F
 GLIBC_2.25 strfromd F
 GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
+GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __strtof128_internal F
 GLIBC_2.26 __wcstof128_internal F
 GLIBC_2.26 _hurd_exec_paths F
diff --git a/sysdeps/mach/hurd/i386/libm.abilist b/sysdeps/mach/hurd/i386/libm.abilist
index a19a69ce6a..bb077b9030 100644
--- a/sysdeps/mach/hurd/i386/libm.abilist
+++ b/sysdeps/mach/hurd/i386/libm.abilist
@@ -474,7 +474,6 @@ GLIBC_2.26 __gammaf128_r_finite F
 GLIBC_2.26 __hypotf128_finite F
 GLIBC_2.26 __iseqsigf128 F
 GLIBC_2.26 __isinff128 F
-GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __issignalingf128 F
 GLIBC_2.26 __j0f128_finite F
 GLIBC_2.26 __j1f128_finite F
diff --git a/sysdeps/unix/sysv/linux/i386/libc.abilist b/sysdeps/unix/sysv/linux/i386/libc.abilist
index ddc5837059..ed631c0423 100644
--- a/sysdeps/unix/sysv/linux/i386/libc.abilist
+++ b/sysdeps/unix/sysv/linux/i386/libc.abilist
@@ -2002,6 +2002,7 @@ GLIBC_2.25 getrandom F
 GLIBC_2.25 strfromd F
 GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
+GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __strtof128_internal F
 GLIBC_2.26 __wcstof128_internal F
 GLIBC_2.26 preadv2 F
diff --git a/sysdeps/unix/sysv/linux/i386/libm.abilist b/sysdeps/unix/sysv/linux/i386/libm.abilist
index 0ab740dd97..335b5e7aa2 100644
--- a/sysdeps/unix/sysv/linux/i386/libm.abilist
+++ b/sysdeps/unix/sysv/linux/i386/libm.abilist
@@ -481,7 +481,6 @@ GLIBC_2.26 __gammaf128_r_finite F
 GLIBC_2.26 __hypotf128_finite F
 GLIBC_2.26 __iseqsigf128 F
 GLIBC_2.26 __isinff128 F
-GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __issignalingf128 F
 GLIBC_2.26 __j0f128_finite F
 GLIBC_2.26 __j1f128_finite F
diff --git a/sysdeps/unix/sysv/linux/ia64/libc.abilist b/sysdeps/unix/sysv/linux/ia64/libc.abilist
index e3b345b803..e4e0bfb2b8 100644
--- a/sysdeps/unix/sysv/linux/ia64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/ia64/libc.abilist
@@ -1872,6 +1872,7 @@ GLIBC_2.25 getrandom F
 GLIBC_2.25 strfromd F
 GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
+GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __strtof128_internal F
 GLIBC_2.26 __wcstof128_internal F
 GLIBC_2.26 preadv2 F
diff --git a/sysdeps/unix/sysv/linux/ia64/libm.abilist b/sysdeps/unix/sysv/linux/ia64/libm.abilist
index c8e8fd7142..ec82b83e6f 100644
--- a/sysdeps/unix/sysv/linux/ia64/libm.abilist
+++ b/sysdeps/unix/sysv/linux/ia64/libm.abilist
@@ -411,7 +411,6 @@ GLIBC_2.26 __gammaf128_r_finite F
 GLIBC_2.26 __hypotf128_finite F
 GLIBC_2.26 __iseqsigf128 F
 GLIBC_2.26 __isinff128 F
-GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __issignalingf128 F
 GLIBC_2.26 __j0f128_finite F
 GLIBC_2.26 __j1f128_finite F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libc.abilist b/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libc.abilist
index 0ea50dc851..d89e2ca6bb 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libc.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libc.abilist
@@ -2183,6 +2183,7 @@ GLIBC_2.25 getrandom F
 GLIBC_2.25 strfromd F
 GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
+GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __strtof128_internal F
 GLIBC_2.26 __wcstof128_internal F
 GLIBC_2.26 preadv2 F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libm.abilist b/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libm.abilist
index 4f8d3c1191..8266bc32f4 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libm.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc64/le/libm.abilist
@@ -478,7 +478,6 @@ GLIBC_2.26 __gammaf128_r_finite F
 GLIBC_2.26 __hypotf128_finite F
 GLIBC_2.26 __iseqsigf128 F
 GLIBC_2.26 __isinff128 F
-GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __issignalingf128 F
 GLIBC_2.26 __j0f128_finite F
 GLIBC_2.26 __j1f128_finite F
diff --git a/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist b/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
index 2744bba4af..4e4682c657 100644
--- a/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/64/libc.abilist
@@ -1853,6 +1853,7 @@ GLIBC_2.25 getrandom F
 GLIBC_2.25 strfromd F
 GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
+GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __strtof128_internal F
 GLIBC_2.26 __wcstof128_internal F
 GLIBC_2.26 preadv2 F
diff --git a/sysdeps/unix/sysv/linux/x86_64/64/libm.abilist b/sysdeps/unix/sysv/linux/x86_64/64/libm.abilist
index 89c4ac484d..b6a088ca64 100644
--- a/sysdeps/unix/sysv/linux/x86_64/64/libm.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/64/libm.abilist
@@ -472,7 +472,6 @@ GLIBC_2.26 __gammaf128_r_finite F
 GLIBC_2.26 __hypotf128_finite F
 GLIBC_2.26 __iseqsigf128 F
 GLIBC_2.26 __isinff128 F
-GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __issignalingf128 F
 GLIBC_2.26 __j0f128_finite F
 GLIBC_2.26 __j1f128_finite F
diff --git a/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist b/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist
index ce2f4fb72b..8151ac474e 100644
--- a/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/x32/libc.abilist
@@ -2106,6 +2106,7 @@ GLIBC_2.25 getrandom F
 GLIBC_2.25 strfromd F
 GLIBC_2.25 strfromf F
 GLIBC_2.25 strfroml F
+GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __strtof128_internal F
 GLIBC_2.26 __wcstof128_internal F
 GLIBC_2.26 preadv2 F
diff --git a/sysdeps/unix/sysv/linux/x86_64/x32/libm.abilist b/sysdeps/unix/sysv/linux/x86_64/x32/libm.abilist
index d3c9cec71a..dfb5a7fa79 100644
--- a/sysdeps/unix/sysv/linux/x86_64/x32/libm.abilist
+++ b/sysdeps/unix/sysv/linux/x86_64/x32/libm.abilist
@@ -472,7 +472,6 @@ GLIBC_2.26 __gammaf128_r_finite F
 GLIBC_2.26 __hypotf128_finite F
 GLIBC_2.26 __iseqsigf128 F
 GLIBC_2.26 __isinff128 F
-GLIBC_2.26 __isnanf128 F
 GLIBC_2.26 __issignalingf128 F
 GLIBC_2.26 __j0f128_finite F
 GLIBC_2.26 __j1f128_finite F